/*
 * config_expression.cpp
 *
 *  Created on: Jun 15, 2016
 *      Author: strazce
 */


#include "conf/scalar_config_expression.h"
#include "utils/basic_logger.h"

namespace opice {
namespace conf {

ScalarConfigExpression::ScalarConfigExpression(const std::string &expr_string)
    : _table(), _expr(), _parser(),
      _r(VPOS::Zeros()), _t(0),
      _original_expr(expr_string)
{

    _table.add_variable("x", _r.x);
    _table.add_variable("y", _r.y);
    _table.add_variable("z", _r.z);
    _table.add_variable("t", _t);

    _expr.register_symbol_table(_table);

    if (!_parser.compile(expr_string, _expr)){
        LE << "'" << _parser.error().c_str() << "' in expression: '"
           << expr_string;
    }
}

Scalar ScalarConfigExpression::get(const VPOS &r, Scalar t) {
    _r = r;
    _t = t;
    return _expr.value();
}

}
}
