/*
 * input_reader_boost.h
 *
 *  Created on: Feb 10, 2011
 *      Author: strazce
 */

#ifndef INPUT_READER_BOOST_H_
#define INPUT_READER_BOOST_H_

#include <boost/program_options.hpp>
#include <vector>
#include <string>

#include "conf/input_reader.h"
#include "settings.h"

namespace opice {
namespace conf {
/** @brief Implementation of InputReader using boost::program_options library.
 *
 */
class InputReaderBoost: public InputReader {
public:
    InputReaderBoost(conf::Settings* sett);
    void read_config_file(std::string filename);

private:
    conf::Settings* _settings;

    void parse_string(const std::string &s, std::vector<int> &elems);
    void parse_string(const std::string &s, VFLD &vect);
    void parse_string(const std::string &s, VI &vect);

//    BorderType get_border_type(int bt);
//    PulseType get_pulse_type(int pt);
//    PulsePolarization get_pulse_polarization(int pp);
//    Axis get_axis(int ax);


};

}
}

#endif /* INPUT_READER_BOOST_H_ */
