/*
 * config_expression.h
 *
 *  Created on: Jun 15, 2016
 *      Author: strazce
 */

#ifndef INCLUDE_CONF_SCALAR_CONFIG_EXPRESSION_H_
#define INCLUDE_CONF_SCALAR_CONFIG_EXPRESSION_H_

#include "conf/exprtk.hpp"
#include "common.h"

namespace opice {
namespace conf {

class ScalarConfigExpression {
public:
    ScalarConfigExpression(const std::string &expr_string);
    Scalar get(const VPOS &r, Scalar t);

    const std::string & original_expr(){ return _original_expr; };

private:
    exprtk::symbol_table<Scalar>    _table;
    exprtk::expression<Scalar>      _expr;
    exprtk::parser<Scalar>          _parser;

    VPOS _r;
    Scalar _t;

    std::string _original_expr;
};


}
}



#endif /* INCLUDE_CONF_SCALAR_CONFIG_EXPRESSION_H_ */
