/*
 * settings.h
 *
 *  Created on: 18 May 2016
 *      Author: strazce
 */

#ifndef INCLUDE_CONF_SETTINGS_H_
#define INCLUDE_CONF_SETTINGS_H_

#include "common.h"
#include "scalar_config_expression.h"
#include "vector_config_expression.h"

namespace opice {
namespace conf {

struct FieldsSettings {
    VectorConfigExpression<DIM_VEL>* E0 = nullptr;     //TODO: Smart pointer
    VectorConfigExpression<DIM_VEL>* B0 = nullptr;     //TODO: Smart pointer

    std::string _E0 = "0,0,0";  //TODO: Generalize for N-dimensions
    std::string _B0 = "0,0,0";  //TODO: Generalize for N-dimensions
    void init();
};

struct PlasmaSettings {
    VI min = VI::Zeros();
    VI max = VI::Zeros();
};

//TODO: Je tohle potreba? Z pohledu readru to vypada, ze vsechno celkem nahodne patri do DomainSettings.
//      Asi by bylo lepsi nechat plasma i fields jako primy potomky hlavnich settings, a tenhle objekt
//      uplne zrusit (a info o MPI velikostech vyresit jinak)
struct DomainSettings {
    PlasmaSettings plasma;
    FieldsSettings fields;
    VI size = VI::Zeros();
};

struct Settings {

    VI phys_size = VI::Zeros();

    int nsteps = 0;
    DomainSettings domain;

    void validate();

};

}
}

#endif /* INCLUDE_CONF_SETTINGS_H_ */
