/*
 * box.h
 *
 *  Created on: 18 May 2016
 *      Author: strazce
 */

#ifndef INCLUDE_DATA_BOX_H_
#define INCLUDE_DATA_BOX_H_

#include "common.h"
#include "data/domain.h"

#include <memory>
#include "conf/settings.h"

namespace opice {
namespace data {

class Box {
public:
    Box(conf::Settings* settings);

    void init_domain();

    Domain* domain(){ return _domain.get(); }

private:
    conf::Settings* _settings;

    std::unique_ptr<conf::DomainSettings> _old_domain_settings; ///< Saves the original state of domain settings object before being split to MPI subdomains

    std::unique_ptr<Domain> _domain;

    std::unique_ptr<Domain> cut_mpi_domain();
};

} /* namespace data */
} /* namespace opice */

#endif /* INCLUDE_DATA_BOX_H_ */
