/*
 * vector_expressions_free.h
 *
 *  Created on: Apr 7, 2016
 *      Author: strazce
 */

#ifndef INCLUDE_CONTAINER_FREE_OPS_H_
#define INCLUDE_CONTAINER_FREE_OPS_H_

#include <iostream>
#include <typeinfo>

namespace opice {
namespace data {
namespace container_soa {

template<typename T1, int CDIM, typename IDX, typename DIFF>
inline auto static rot_impl(ContainerSoa<T1, CDIM> &f, const IDX &idx, const DIFF &idr, int dir) {
    const int i = idx.x;
    const int j = idx.y;
    const int k = idx.z;
    const int ii = idx.x + dir;
    const int jj = idx.y + dir;
    const int kk = idx.z + dir;
    const IDX base = IDX(i,j,k);

    return T1(
            (f[base][2] - f[IDX(i,jj,k)][2]) * idr.y
          - (f[base][1] - f[IDX(i,j,kk)][1]) * idr.z,
            (f[base][0] - f[IDX(i,j,kk)][0]) * idr.z
          - (f[base][2] - f[IDX(ii,j,k)][2]) * idr.x,
            (f[base][1] - f[IDX(ii,j,k)][1]) * idr.x
          - (f[base][0] - f[IDX(i,jj,k)][0]) * idr.y
            );
}

}} // namespace opice::data::container_soa

template<typename T1, int CDIM, typename IDX, typename DIFF>
inline auto static rot(data::container_soa::ContainerSoa<T1, CDIM> &f, const IDX &idx, const DIFF &idr, int dir) {
    return data::container_soa::rot_impl(f, idx, idr, dir);
}

}

#endif /* INCLUDE_CONTAINER_FREE_OPS_H_ */
