/*
 * domain.h
 *
 *  Created on: 18 May 2016
 *      Author: strazce
 */

#ifndef INCLUDE_DATA_DOMAIN_H_
#define INCLUDE_DATA_DOMAIN_H_

#include <memory>

#include "conf/settings.h"
#include "common.h"
#include "data/grid.h"

namespace opice {
namespace data {

class Domain {
public:
    Domain(conf::DomainSettings* settings);

    void init();

    Grid* grid() { return _grid.get(); }

private:
    conf::DomainSettings* _settings;
    std::unique_ptr<Grid> _grid;
    void init_plasma();
    void init_fields();
};

} /* namespace data */
} /* namespace opice */

#endif /* INCLUDE_DATA_DOMAIN_H_ */
