/*
 * vector_expressions_free.h
 *
 *  Created on: Apr 7, 2016
 *      Author: strazce
 */

#ifndef INCLUDE_DATA_VECTOR_FREE_OPS_H_
#define INCLUDE_DATA_VECTOR_FREE_OPS_H_

namespace opice {
namespace data {
namespace vector {

template<typename T1, typename T2, std::size_t DIM, bool SOA>
inline static auto operator+(Vector<T1, DIM, SOA> a, Vector<T2, DIM, SOA> b) {
    using V = Vector<typename std::remove_const_t<typename std::remove_reference_t<decltype(a[0]+b[0])>>, DIM, SOA>;
    V r(a);
    return r += b;
}

template<typename T1, typename T2, std::size_t DIM, bool SOA>
inline static auto operator-(Vector<T1, DIM, SOA> a, Vector<T2, DIM, SOA> b) {
    using V = Vector<typename std::remove_const_t<typename std::remove_reference_t<decltype(a[0]-b[0])>>, DIM, SOA>;
    V r(a);
    return r -= b;
}

template<typename R, typename T, std::size_t DIM, bool SOA>
inline static auto operator*(R c, Vector<T, DIM, SOA> a) {
    using V = Vector<typename std::remove_const_t<typename std::remove_reference_t<decltype(a[0]*c)>>, DIM, SOA>;
    V r(a);
    return r *= c;
}

template<typename T, typename R, std::size_t DIM, bool SOA>
inline static auto operator*(Vector<T, DIM, SOA> a, R c) {
    return c * a;
}

template<typename R, typename T, std::size_t DIM, bool SOA>
inline static auto operator/(Vector<T, DIM, SOA> a, R c) {
    using V = Vector<typename std::remove_const_t<typename std::remove_reference_t<decltype(a[0]*c)>>, DIM, SOA>;
    V r(a);
    return r /= c;
}

template<typename T, std::size_t DIM, bool SOA>
inline static std::ostream & operator<<(std::ostream & co,
        Vector<T, DIM, SOA> const & v) {
    return co << '(' << v.x << ',' << v.y << ',' << v.z << ')';
}

}}} // namespace opice::data::vector

#endif /* INCLUDE_DATA_VECTOR_FREE_OPS_H_ */
