/*
 * experiment.h
 *
 *  Created on: 18 May 2016
 *      Author: strazce
 */

#ifndef INCLUDE_EXPERIMENT_H_
#define INCLUDE_EXPERIMENT_H_

#include "data/box.h"

#include <memory>
#include "conf/settings.h"

namespace opice {

class Experiment {
public:
    Experiment(std::unique_ptr<conf::Settings> settings);
    ~Experiment();
    void run();
    void load_data();

private:
    std::unique_ptr<conf::Settings> _settings;  ///< Settings object for the running experiment on this node. Note that its contents can change during the run.
    std::unique_ptr<data::Box> _box;
};

} /* namespace opice */

#endif /* INCLUDE_EXPERIMENT_H_ */
