/*
 * field_fdtd.h
 *
 */

#ifndef INCLUDE_PHYSICS_FIELD_FDTD1_H_
#define INCLUDE_PHYSICS_FIELD_FDTD1_H_

#include "common.h"
#include "field_solver.h"
#include "data/grid.h"
//#include "grid_iterator.h"

namespace opice {
namespace physics {

/** @brief Implementation of the FDTD solver for Maxwell's equations.
 *
 */
class FieldFDTD1
        : public FieldSolver
//, public GridIterator<FieldFDTD1>
{
public:
    FieldFDTD1(const VSTI& s, data::Grid* g);

    void advance();

private:
    data::Grid* _grid;
    inline void advance_B_half(const VI &idx);
    inline void advance_E(const VI &idx);
    VFLD _fB0;
};

}
}

#endif /* INCLUDE_PHYSICS_FIELD_FDTD1_H_ */
