/*
 * field_solver.h
 *
 */

#ifndef INCLUDE_PHYSICS_FIELD_SOLVER_H_
#define INCLUDE_PHYSICS_FIELD_SOLVER_H_

#include "common.h"
#include "data/grid.h"
#include "physics/stepper.h"

namespace opice {

namespace physics {

/** @brief Interface for the Maxwell's equations solver.
 *
 */
class FieldSolver
        : public Stepper
{
public:
    FieldSolver(const VSTI& s): Stepper(s) {};
    virtual ~FieldSolver(){};
    virtual void advance(){};
    virtual void currents(){};
    virtual void init(data::Grid*){};
};

}
}

#endif /* INCLUDE_PHYSICS_FIELD_SOLVER_H_ */
