/*
 * cpu_architecture.h
 *
 *  Created on: Feb 11, 2016
 *      Author: strazce
 */

#ifndef UTILS_CPU_ARCHITECTURE_H_
#define UTILS_CPU_ARCHITECTURE_H_

namespace opice {
namespace utils {

#if defined ( __AVX512F__ ) || defined ( __AVX512__ )
constexpr int REGISTER_LENGTH   = 512;
constexpr int REGISTER_SP       = 16;
constexpr int REGISTER_DP       = 8;
constexpr int ALIGNMENT_BYTES   = 64;

#elif defined ( __AVX__ )
constexpr int REGISTER_LENGTH   = 256;
constexpr int REGISTER_SP       = 8;
constexpr int REGISTER_DP       = 4;
constexpr int ALIGNMENT_BYTES   = 32;

#elif defined ( __SSE2__ ) || defined ( __x86_64__ )
constexpr int REGISTER_LENGTH   = 128;
constexpr int REGISTER_SP       = 4;
constexpr int REGISTER_DP       = 2;
constexpr int ALIGNMENT_BYTES   = 16;

#elif defined ( __SSE__ )
constexpr int REGISTER_LENGTH   = 128;
constexpr int REGISTER_SP       = 4;
constexpr int REGISTER_DP       = 1;
constexpr int ALIGNMENT_BYTES   = 16;

#else
constexpr int REGISTER_LENGTH   = -1;
constexpr int REGISTER_SP       = 1;
constexpr int REGISTER_DP       = 1;
constexpr int ALIGNMENT_BYTES   = 16;

#endif

} } // namespace opice::utils

#endif /* INCLUDE_UTILS_CPU_ARCHITECTURE_H_ */
