/*
 * metaprog.h
 *
 *  Created on: Mar 24, 2016
 *      Author: strazce
 */

#ifndef INCLUDE_UTILS_METAPROG_H_
#define INCLUDE_UTILS_METAPROG_H_

namespace opice {
namespace utils {

template<typename T, typename... Tail> constexpr
static auto multiply_arg_pack_int(T head, Tail... tail) {
    const std::array<T, sizeof...(tail)+1>& dims { head, tail... }; // creates an array from the argument pack 'n...'
    return std::accumulate(dims.begin(), dims.end(), 1, std::multiplies<T>());
}

template<int N, typename V>
struct gen_tuple {
    using type = decltype (
            std::tuple_cat(std::declval<std::tuple<V>>(),
                    std::declval<typename
                        gen_tuple<N-1, V>::type
                    >()));
};
template<typename V>
struct gen_tuple<0, V> {
    using type = std::tuple<>;
};

}} // namespace opice::utils

#endif /* INCLUDE_UTILS_METAPROG_H_ */
