/*
 * random_generator.h
 *
 */

#ifndef INCLUDE_UTILS_RANDOM_GENERATOR_H_
#define INCLUDE_UTILS_RANDOM_GENERATOR_H_

#include "common.h"
#include <random>

namespace opice {
namespace utils {

/** @brief Generator of pseudo-random numbers
 *
 *  Basic version - encapsulates standard C++11 PRNG engine
 */
class RandomGenerator {
public:
    RandomGenerator();

    void seed(int s);
    double gauss();
    double uniform();
private:
    std::mt19937                        _gen;
    std::uniform_real_distribution<>    _dist_uni;
    std::normal_distribution<>          _dist_normal;
};

}
}

#endif /* INCLUDE_UTILS_RANDOM_GENERATOR_H_ */
