//============================================================================
// Name        : opice.cpp
// Author      : Jiri Vyskocil
// Version     :
// Copyright   : Licensed under GPL v2 or later
// Description : Open Particle-in-Cell Environment v2
//============================================================================

#include "experiment.h"
#include "conf/input_reader_boost.h"

#include <iostream>
#include <memory>

#include "conf/settings.h"

using namespace std;
using namespace opice;
using namespace opice::conf;
using namespace opice::conf;

/** @namespace opice
 *  @brief Namespace for the OPICE project. Everything related to the program goes here.
 */
namespace opice {
    int rank_order = 0;    ///< MPI rank. Has to be global - needs to be always available to the logger.
}

using namespace opice;

int main() {

    std::unique_ptr<Settings> s(new Settings);

    std::unique_ptr<InputReaderBoost> reader(new InputReaderBoost(s.get()));
    reader->read_config_file("input.txt");

    s->validate();

    auto original_settings = std::make_unique<Settings>(*s);   // Save a copy of the settings object after validation
    //TODO: The state original_settings object could be written to a file or whatever...

    rank_order = 0;

    auto experiment = std::make_unique<Experiment>(move(s));

    experiment->load_data();
    experiment->run();

	return 0;
}

